package org.jenkinsci.plugins.p4_client.review;

import hudson.Extension;
import hudson.Launcher;
import hudson.model.BuildListener;
import hudson.model.AbstractBuild;
import hudson.model.AbstractProject;
import hudson.tasks.BuildStepDescriptor;
import hudson.tasks.BuildStepMonitor;
import hudson.tasks.Notifier;
import hudson.tasks.Publisher;

import java.io.IOException;
import java.util.logging.Logger;

import org.kohsuke.stapler.DataBoundConstructor;

public class ReviewNotifier extends Notifier {

	@DataBoundConstructor
	public ReviewNotifier() {
		LOGGER.info("ReviewNotifier -> DataBoundConstructor");
	}

	@Override
	public boolean perform(AbstractBuild<?, ?> build, Launcher launcher,
			BuildListener listener) throws InterruptedException, IOException {
		LOGGER.info("ReviewNotifier -> perform");
		return true;
	}

	public BuildStepMonitor getRequiredMonitorService() {
		// This BuildStep is only executed after the previous build is fully
		// completed.
		return BuildStepMonitor.BUILD;
	}

	@Extension
	public static final class DescriptorImpl extends
			BuildStepDescriptor<Publisher> {

		@Override
		public boolean isApplicable(Class<? extends AbstractProject> jobType) {
			return true;
		}

		@Override
		public String getDisplayName() {
			return "Review Notifier";
		}

	}

	final static Logger LOGGER = Logger.getLogger(ReviewNotifier.class
			.getName());
}
